Bug 316031 - dm-mirror: incorrect order of mirror presuspend ops causes cluster mirror hang
dm-mirror: incorrect order of mirror presuspend ops causes cluster mirror hang
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
All Linux
high Severity high
: ---
: ---
Assigned To: Jonathan Earl Brassow
Martin Jenner
Depends On:
Blocks: 358871
  Show dependency treegraph
Reported: 2007-10-02 16:24 EDT by Jonathan Earl Brassow
Modified: 2007-11-16 20:14 EST (History)
4 users (show)

See Also:
Fixed In Version: RHBA-2007-0791
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2007-11-15 11:33:08 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Jonathan Earl Brassow 2007-10-02 16:24:16 EDT
Cluster mirrors do not (and can not) allow writes to mirror regions which have
not recovered yet.

When a mirror suspends it:
1) stops recovery
2) flushes the work queue (finishing outstanding writes)
3) calls log presuspend

The log has no way of knowing that the mirror is suspending until #3, so it
blocks any outstanding writes to regions that are not-in-sync.  This could hang
the mirror because recovery has been stopped and the not-in-sync regions will
never be cleared - delaying the writes indefinitely.

The solution is to switch the order of operations to:
1) stop recovery
2) call log presuspend
3) flush work queue

By doing this, the log knows that recovery has been stopped and that there will
be no collisions with writes.  Therefore, it can allow writes to regions which
have not yet been recovered.
Comment 3 Jason Baron 2007-10-03 18:35:12 EDT
committed in stream U6 build 61. A test kernel with this patch is available from
Comment 6 errata-xmlrpc 2007-11-15 11:33:08 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.


Note You need to log in before you can comment on or make changes to this bug.